﻿Option Strict On

Imports IV_Class
Imports Inventor


Public Class Form1
    Dim IV_App As Inventor.Application
    Dim IV_Doc As Inventor.Document 'IV-Dokument allgemein
    Dim IV_Part As Inventor.PartDocument 'Bauteil-Dokument
    Dim IV_BG As Inventor.AssemblyDocument 'Baugruppendokument
    Dim PropSets As Inventor.PropertySets


    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        ClassMain.Start()
        Dim a As Projekt = ClassMain.WahlProjekt
        If a IsNot Nothing Then
            Me.Text = String.Format("Titel: {0} Projekt: {1} Firma: {2}", a.iProps("Title"), a.iProps("Project"), a.iProps("Company"))
        End If

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub


    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Try
            IV_App = CType(System.Runtime.InteropServices.Marshal.GetActiveObject("Inventor.Application"), Application) 'Gibt die aktive IV-App zurück
            IV_Doc = IV_App.ActiveDocument 'gibt das aktuelle Dokument der IV_App zurück
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Inventor ist nicht gestartet")
            Exit Sub
        End Try


        If IV_Doc Is Nothing Then
            MessageBox.Show("Es ist kein Dokument aktiv")
            Exit Sub
        Else
            Me.Text = IV_Doc.DocumentType.ToString 'Ausgabe des Dukumenttypes
            Label1.Text = IV_Doc.DisplayName 'Ausgabe des Dokumentnamens
            Label1.Text &= vbCrLf & IV_Doc.FullDocumentName 'Dateiname + Pfad

            PropSets = IV_Doc.PropertySets 'Alle Propertysets des akt. Dokumnetes laden

            'Die Eigenschaft ProperttySets bestet aus folgenden PropertySet, welche jeweils die Eigenschaften beinhalten
            Dim PropSet As Inventor.PropertySet
            Dim iPropZus As String = "{F29F85E0-4FF9-1068-AB91-08002B27B3D9}" ' : Inventor - Zusammenfassungsinformationen
            Dim iPropZusDoc As String = "{D5CDD502-2E9C-101B-9397-08002B2CF9AE}" ' : Inventor - Zus.-fassungsinfo f. Dokument
            Dim iPropTracking As String = "{32853F0F-3444-11D1-9E93-0060B03C1CA6}" ' : Design Tracking - Eigenschaften
            Dim iPropBenutzer As String = "{D5CDD505-2E9C-101B-9397-08002B2CF9AE}" ' : Inventor - Benutzerdefinierte Eigenschaften
            Dim iPropiLogic As String = "{2C540830-0723-455E-A8E2-891722EB4C3E}" ' : iLogicEventsRules

            Dim P As Inventor.Property = GetProperty(PropSets, TextBox1.Text) 'Abfrage der Propertys, Nothing wenn Property nicht existiert
            If P IsNot Nothing Then
                'Die Property wurde gefunden
                Debug.Print("iProp {0} = {1}", P.Name, P.Value) 'Anzeige von Name und Wert der angefragten Property
            Else
                'Wenn die Property nicht gefunden wurde
                If MessageBox.Show("Diese iProperty existiert nicht", "Benutzerproperty anlegen?", MessageBoxButtons.YesNo, MessageBoxIcon.Hand) = Windows.Forms.DialogResult.Yes Then
                    If TextBox1.Text > "" Then
                        Benutzer_Property(IV_Doc.PropertySets, TextBox1.Text, TextBox2.Text)
                    End If
                End If
            End If
        End If
    End Sub

    ''' <summary>
    ''' Gibt eine angefragte Property inkl. Wert zurück. Nothing wenn die Property nicht existiert
    ''' </summary>
    ''' <param name="PropertySets"></param>
    ''' <param name="Suchname"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function GetProperty(ByVal PropertySets As Inventor.PropertySets, ByVal Suchname As String) As Inventor.Property

        For Each PropSet As Inventor.PropertySet In PropertySets 'Property-Sets durchlaufen
            Debug.Print(PropSet.InternalName & " : " & PropSet.DisplayName)

            For Each Prop As Inventor.Property In PropSet 'iProperties eines Set durchlaufen

                'Abfangen von Property-Werten, die nicht als String darstellbar sind
                Dim Wert As Object
                Try
                    Wert = Prop.Value
                    If Wert Is Nothing Then Wert = ""
                Catch ex As Exception
                    Wert = ""
                End Try

                Debug.Print("Name: " & Prop.Name & " : " & Wert.ToString)
                If Prop.Name = Suchname Then
                    Return Prop
                End If
            Next
        Next
        Return Nothing
    End Function

    ''' <summary>
    ''' Schreiben bzw. Erstellen einer Benutzerproperty
    ''' </summary>
    ''' <param name="Propertysets">Propertysets des aktuellen Dokumentes</param>
    ''' <param name="Name">Name der Benutzerproperty</param>
    ''' <param name="Wert">Wert der Benutzerproperty</param>
    ''' <remarks></remarks>
    Public Sub Benutzer_Property(ByVal Propertysets As Inventor.PropertySets, ByVal Name As String, ByVal Wert As Object)
        Dim _iV_CustomPropertySet As PropertySet
        '_iV_CustomPropertySet = Propertysets.Item("Inventor User Defined Properties")
        _iV_CustomPropertySet = Propertysets.Item("Inventor - Benutzerdefinierte Eigenschaften")
        _iV_CustomPropertySet.Add(Wert, Name)
    End Sub

End Class
